; Programm zum Setzen des _FDC-Cookies mit HD-Flag

          text

hdcookie: pea       copyrght            ; Copyrightmessage
          move.w    #9,-(sp)            ; per CconWs ausgeben
          trap      #1                  ; GEMDOS
          addq.l    #6,sp               ; Stack aufrumen

          pea       install             ; Installation im Supervisor
          move.w    #38,-(sp)           ; Supexec
          trap      #14                 ; XBIOS
          addq.l    #6,sp               ; Stack aufrumen

          tst.w     d0                  ; was ist passiert?
          bne.s     fehler              ; hat nicht geklappt...

          pea       instok              ; "Alles klar..."
          move.w    #9,-(sp)            ; per CconWs
          trap      #1                  ; GEMDOS
          addq.l    #6,sp               ; Stack aufrumen
          bra.s     raus

fehler:   pea       instfail            ; "Hat nicht funktioniert..."
          move.w    #9,-(sp)            ; per CconWs
          trap      #1                  ; GEMDOS
          addq.l    #6,sp               ; Stack aufrumen

raus:     clr.w     -(sp)               ; Pterm
          trap      #1                  ; und zurck an's GEMDOS

install:  tst.l     $5A0                ; ist berhaupt ein CookieJar da?
          beq.s     nixgut              ; nein, gleich Ende...
          movea.l   $5A0,a0             ; Zeiger auf CookieJar holen
          moveq     #0,d0               ; Cookiezhler auf Null setzen
such:     tst.l     (a0)                ; letzter Eintrag?
          beq.s     weiter              ; ja, weiter installieren
          cmpi.l    #'_FDC',(a0)        ; ist das der _FDC-Cookie?
          beq.s     nixgut              ; ja, Installation abbrechen
          addq.w    #1,d0               ; INC zhler
          addq.l    #8,a0               ; sonst nchsten Cookie nehmen
          bra.s     such                ; und weiter suchen
weiter:   cmp.l     4(a0),d0            ; CookieJar voll?
          beq.s     nixgut              ; ja...
          move.l    #'_FDC',(a0)+       ; _FDC-Cookie setzen
          move.l    (a0),d0             ; Anzahl retten
          move.l    #$1000000,(a0)+     ; HD mglich, keine weiteren Infos
          clr.l     (a0)+               ; Ende-Cookie verschieben
          move.l    d0,(a0)             ; Anzahl verschieben
          moveq     #0,d0               ; -> OK
          bra.s     endinst
nixgut:   moveq     #-1,d0              ; -> FEHLER
endinst:  rts

          data

copyrght: dc.b      13,10,27,112
          dc.b      " HD-Cookie Install V1.0 25.01.1993, R. Skuplik "
          dc.b      27,113,13,10
          dc.b      " 1993 by WRS Software-Design, <0209> 873001"
          dc.b      13,10,0
instok:   dc.b      "~> Installation erfolgreich.",13,10,0
instfail: dc.b      10,27,112
          dc.b      "~> Installation abgebrochen. "
          dc.b      27,113,13,10
          dc.b      "_FDC-Cookie bereits vorhanden oder "
          dc.b      "CookieJar voll/fehlt..."
          dc.b      13,10,0

          end

